package javax.accessibility;

import java.util.Vector;

public class AccessibleStateSet
{
    protected Vector<AccessibleState> states;
    
    public AccessibleStateSet() {
        this.states = null;
        this.states = null;
    }
    
    public AccessibleStateSet(AccessibleState[] array) {
        this.states = null;
        if (array.length != 0) {
            this.states = new Vector(array.length);
            for (int i = 0; i < array.length; ++i) {
                if (!this.states.contains(array[i])) {
                    this.states.addElement(array[i]);
                }
            }
        }
    }
    
    public boolean add(AccessibleState accessibleState) {
        if (this.states == null) {
            this.states = new Vector();
        }
        if (!this.states.contains(accessibleState)) {
            this.states.addElement(accessibleState);
            return true;
        }
        return false;
    }
    
    public void addAll(AccessibleState[] array) {
        if (array.length != 0) {
            if (this.states == null) {
                this.states = new Vector(array.length);
            }
            for (int i = 0; i < array.length; ++i) {
                if (!this.states.contains(array[i])) {
                    this.states.addElement(array[i]);
                }
            }
        }
    }
    
    public boolean remove(AccessibleState obj) {
        return this.states != null && this.states.removeElement(obj);
    }
    
    public void clear() {
        if (this.states != null) {
            this.states.removeAllElements();
        }
    }
    
    public boolean contains(AccessibleState o) {
        return this.states != null && this.states.contains(o);
    }
    
    public AccessibleState[] toArray() {
        if (this.states == null) {
            return new AccessibleState[0];
        }
        AccessibleState[] array = new AccessibleState[this.states.size()];
        for (int i = 0; i < array.length; ++i) {
            array[i] = (AccessibleState)this.states.elementAt(i);
        }
        return array;
    }
    
    @Override
    public String toString() {
        String str = null;
        if (this.states != null && this.states.size() > 0) {
            str = ((AccessibleState)this.states.elementAt(0)).toDisplayString();
            for (int i = 1; i < this.states.size(); ++i) {
                str = str + "," + ((AccessibleState)this.states.elementAt(i)).toDisplayString();
            }
            return str;
        }
        return str;
    }
}
